/*==LICENSE==*

CyanWorlds.com Engine - MMOG client, server and tools
Copyright (C) 2011  Cyan Worlds, Inc.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

You can contact Cyan Worlds, Inc. by email legal@cyan.com
 or by snail mail at:
      Cyan Worlds, Inc.
      14617 N Newport Hwy
      Mead, WA   99021

*==LICENSE==*/

#ifndef plDirectShdowMaster_inc
#define plDirectShdowMaster_inc


#include "plShadowMaster.h"
#include "hsGeometry3.h"


class plBoundsIsect;

class plDirectShadowMaster : public plShadowMaster
{
protected:
    mutable hsTArray<plBoundsIsect*>    fIsectPool;
    hsTArray<plShadowSlave*>            fPerspSlavePool;

    virtual void IComputeWorldToLight(const hsBounds3Ext& bnd, plShadowSlave* slave) const;
    virtual void IComputeProjections(plShadowCastMsg* castMsg, plShadowSlave* slave) const;
    virtual void IComputeISect(const hsBounds3Ext& bnd, plShadowSlave* slave) const;
    virtual void IComputeBounds(const hsBounds3Ext& bnd, plShadowSlave* slave) const;

    virtual plShadowSlave* INewSlave(const plShadowCaster* caster);
    virtual plShadowSlave* INextSlave(const plShadowCaster* caster);
    virtual plShadowSlave* IRecycleSlave(plShadowSlave* slave);

    virtual void IBeginRender();

public:
    plDirectShadowMaster();
    virtual ~plDirectShadowMaster();

    CLASSNAME_REGISTER( plDirectShadowMaster );
    GETINTERFACE_ANY( plDirectShadowMaster, plShadowMaster );

};

#endif // plDirectShdowMaster_inc
